;------------------------------------------------------------------------
; VGA eXtra! Assembler Include
; Copyright (c) 1993-95 by J.E. Hoffmann
; All rights reserved
;------------------------------------------------------------------------}



;--General Register----------------------------------------
  GR_InputStatus1            EQU 3DAh


;--Cathode Ray Tube Controller-----------------------------
  CC_Index                   EQU 3D4h
  CC_Data                    EQU 3D5h

  cc_HorizontalTotal         EQU 00h
  cc_HorizontalDisplayEnd    EQU 01h
  cc_StartHorizontalBlanking EQU 02h
  cc_EndHorizontalBlanking   EQU 03h
  cc_StartHorizontalRetrace  EQU 04h
  cc_EndHorizontalRetrace    EQU 05h
  cc_VerticalTotal           EQU 06h
  cc_Overflow                EQU 07h
  cc_PresetRowScan           EQU 08h
  cc_MaximumScanLine         EQU 09h
  cc_CursorStart             EQU 0Ah
  cc_CursorEnd               EQU 0Bh
  cc_StartAddressHigh        EQU 0Ch
  cc_StartAddressLow         EQU 0Dh
  cc_CursorLocationHigh      EQU 0Eh
  cc_CursorLocationLow       EQU 0Fh
  cc_StartVerticalRetrace    EQU 10h
  cc_EndVerticalRetrace      EQU 11h
  cc_VerticalDisplayEnd      EQU 12h
  cc_Offset                  EQU 13h
  cc_UnderlineLocation       EQU 14h
  cc_StartVerticalBlanking   EQU 15h
  cc_EndVerticalBlanking     EQU 16h
  cc_ModeControl             EQU 17h
  cc_LineCompare             EQU 18h


;--Graphics Controller-----------------------------
  GC_Index                   EQU 3CEh
  GC_Data                    EQU 3CFh

  gc_SetReset                EQU 00h
  gc_EnableSetReset          EQU 01h
  gc_ColorCompare            EQU 02h
  gc_DataRotate              EQU 03h
  gc_ReadMapSelect           EQU 04h
  gc_Mode                    EQU 05h
  gc_Miscellaneous           EQU 06h
  gc_ColorDontCare           EQU 07h
  gc_BitMask                 EQU 08h


;--Sequencer Controller-----------------------------
  SC_Index                   EQU 3C4h
  SC_Data                    EQU 3C5h

  sc_Reset                   EQU 00h
  sc_ClockingMode            EQU 01h
  sc_MapMask                 EQU 02h
  sc_CharacterMapSelect      EQU 03h
  sc_MemoryMode              EQU 04h


;--Digital Analog Converter-------------------------
  DC_PELAddressReadMode_W    EQU 3C7h
  DC_PELAddressReadMode_R    EQU 3C8h
  DC_PELAddressWriteMode     EQU 3C8h
  DC_PELData                 EQU 3C9h
  DC_DACState                EQU 3C7h
  DC_PELMask                 EQU 3C6h



;--Page Offsets (FlipPage+SwapPage)-----------------
  P0                         EQU 0*3F00h
  P1                         EQU 1*3F00h
  P2                         EQU 2*3F00h
  P3                         EQU 3*3F00h









